-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local objectInstances = {}
local objectInstancesID = {}

local function placeObj(singleMode, objName, objConfig)
	local playerVehicle = be:getPlayerVehicle(0)
    local playerVehicleID = be:getPlayerVehicleID(0)
	local dir = 0
	local rot = 0
	local position = 0
	
    for k, v in pairs(map.objects) do
      if k == playerVehicleID then
        dir = v.dirVec:normalized()
        rot = quatFromDir(dir)
      end
    end
	position = vec3(playerVehicle:getPosition()) - dir*5
	
	if singleMode and objectInstancesID[1] ~= nil then
		objectInstances[1]:setPositionRotation(position.x, position.y, position.z, rot.x, rot.y, rot.z, rot.w)
	else
		if singleMode then
			M.remove(true)
			spawn.spawnVehicle(objName, objConfig, position, rot)
			objectInstances[1] = be:getPlayerVehicle(0)
			objectInstancesID[1] = be:getPlayerVehicleID(0)
		else
			spawn.spawnVehicle(objName, objConfig, position, rot)
			table.insert(objectInstances, be:getPlayerVehicle(0))
			table.insert(objectInstancesID, be:getPlayerVehicleID(0))
		end
		be:enterVehicle(0, playerVehicle)
	end
end

local function removeObj(singleMode)
	if objectInstancesID[1] ~= nil then
		if singleMode then
			objectInstances[1]:delete()
			objectInstances[1] = nil
			objectInstancesID[1] = nil
		else
			table.remove(objectInstances):delete()
			table.remove(objectInstancesID)
		end
	end
end

-- public interface
M.place = placeObj
M.remove = removeObj

return M
