-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local spikestripInstance = nil
local spikestripInstanceID = nil
local checkPoint = nil

local function place()
	local playerVehicle = be:getPlayerVehicle(0)
    local playerVehicleID = be:getPlayerVehicleID(0)
	local dir = 0
	local rot = 0
	local position = 0

    for k, v in pairs(map.objects) do
      if k == playerVehicleID then
        dir = v.dirVec:normalized()
        rot = quatFromDir(dir)
      end
    end
	position = vec3(playerVehicle:getPosition()) - dir*5

	if spikestripInstanceID ~= nil then
		rot = rot * quat(0,0,1,0) -- rotate 180 degrees
		spikestripInstance:setPositionRotation(position.x, position.y, position.z, rot.x, rot.y, rot.z, rot.w)
	else
		M.remove()
		spawn.spawnVehicle("spikestrip", "spikestrip", position, rot)
		spikestripInstance = be:getPlayerVehicle(0)
		spikestripInstanceID = be:getPlayerVehicleID(0)
		be:enterVehicle(0, playerVehicle)
	end
end

local function remove()
	if spikestripInstanceID ~= nil then
		spikestripInstance:delete()
		spikestripInstance = nil
		spikestripInstanceID = nil
	end
end

--experimental tire deflation logic with a trigger
--[[
local function updatePosition(spikeStripID)
	local veh = scenetree.findObjectById(spikeStripID)
	if veh ~= nil then
		local rot = quat(veh:getRotation()):toTable()
		local pos = veh:getPosition()
		--checkPoint:setPosition(pos)
		--checkPoint:setPositionRotation() does not work?!
		checkPoint:setTransform(veh:getTransform())
	else
		--spikes got deleted
		M.unsetCheckpoint()
	end
end

local function setCheckpoint(spikeStripID)
	local veh = scenetree.findObjectById(spikeStripID)
	local pos = veh:getPosition()
	--local size = Point3F(3.75,1,5)
	local size = Point3F(3.75,3.75,3.75)

	if checkPoint then
		M.unsetCheckpoint()
	end

	checkPoint = createObject('BeamNGTrigger')
    checkPoint.loadMode = 1 --'Manual'
    --checkPoint:setField("triggerType", 0, 'Box')
    checkPoint:setField("triggerType", 0, 'Sphere')
    --checkPoint.debug = true
    checkPoint.luaFunction = String("extensions.bluetac_spikestrip.onCheckPointPassed")
    checkPoint:registerObject('spikeStripTrigger')
    checkPoint:setPosition(pos)
    checkPoint:setScale(size)
end

local function unsetCheckpoint()
	checkPoint.delete(checkPoint)
	checkPoint = nil
end

local function onCheckPointPassed(data)
	if data['triggerName'] == 'spikeStripTrigger' then
		if data['event'] == 'enter' then
			local veh = scenetree.findObjectById(data['subjectID'])
			veh:queueLuaCommand("beamstate.deflateTires()")
		elseif data['event'] == 'exit' then

		end
	end
end

M.setCheckpoint = setCheckpoint
M.updatePosition = updatePosition
M.unsetCheckpoint = unsetCheckpoint
M.onCheckPointPassed = onCheckPointPassed
]]

-- public interface
M.place = place
M.remove = remove

return M
